
Vn.Checkout = new Class
({
	Extends: Vn.Module

	,activate: function ()
	{
		this.autoStepLocked = true;

		this.$('order-model').setDefault ('customer_id', 'o',
			new Sql.Func ({schema: 'account', name: 'user_get_id'}));

		if (this.$('order').value == 0)
			this.$('defaults').refresh ();
		else
			(new Htk.Toast ()).showWarning (_('RememberReconfiguringImpact'));
	}
	
	,setDefaults: function ()
	{
		var o = this.$('order-form');
		var d = this.$('defaults');

		if (this.$('order').value == 0 && d.ready && o.ready)
		{
			o.insertRow ();
//			o.set ('delivery_method_id', d.get ('delivery_method'));
			o.set ('date_send', new Date ());
			o.set ('agency_id', d.get ('agency_id'));
			o.set ('address_id', d.get ('address_id'));
			this.autoStepLocked = false;
		}
	}
	
	,onOrderReady: function ()
	{
		if (this.$('order').value != 0)
			this.autoStepLocked = false;
	}

	,onOperationsDone: function ()
	{
		if (this.$('order').value == 0)
		{
			(new Htk.Toast ()).showMessage (_('OrderStarted'));
			this.hash.set ({'form': 'ecomerce/catalog'});
		}
		else
			this.conn.execQuery ('CALL basket_update ()',
				this.onBasketUpdated.bind (this));
	}
	
	,onBasketUpdated: function ()
	{
		(new Htk.Toast ()).showMessage (_('OrderUpdated'));
		window.history.back();
	}
	
	,onConfirmClick: function ()
	{
		this.$('order-form').performOperations ();
	}

	,onCancelClick: function ()
	{
		if (this.$('order').value == 0)
			this.hash.set ({'form': 'ecomerce/orders'});
		else
			this.hash.set ({'form': 'ecomerce/basket'});
	}
	
	,agencySteps: ['delivery', 'date', 'address', 'agency', 'confirm-agency']
	,deliverySteps: ['delivery', 'date', 'address', null, 'confirm-delivery']
	,pickupSteps: ['delivery', 'date', 'pickup', null, 'confirm-pickup']
	
	,stepFunc: function (stepIndex)
	{
		var steps;
		var isDelivery;
	
		switch (this.$('rg-delivery').value)
		{
			case 'AGENCY':
				steps = this.agencySteps;
				isDelivery = true;
				break;
			case 'DELIVERY':
				steps = this.deliverySteps;
				isDelivery = true;
				break;
			case 'PICKUP':
			default:
				steps = this.pickupSteps;
				isDelivery = false;
				break;
		}

		var stepId = steps[stepIndex];
		
		if (!stepId)
			return null;

		switch (stepId)
		{
			case 'date':
				Vn.Node.setText (this.$('date-question'), isDelivery ?
					_('OrderDateDeliveryQuestion'):
					_('OrderDatePickupQuestion'));
				this.$('calendar').goToSelectedMonth ();
				break;
			case 'address':
				this.$('addresses').refresh ();
				break;
			case 'agency':
				this.$('agencies').refresh ();
				break;
			case 'pickup':
				this.$('warehouses').refresh ();
				break;
		}
		
		return this.$(stepId +'-step');
	}
	
	,onFieldChange: function ()
	{
		if (!this.autoStepLocked)
			setTimeout (this.goNextStep.bind (this), 75);
	}
	
	,addressRenderer: function (builder, index)
	{
		builder.$('address-div').addEventListener ('click',
			this.onAddressClick.bind (this, index));
	}
	
	,onAddressClick: function (index)
	{
		this.$('address-form').row = index;
		this.$('address').value = this.$('address-form').get ('id');
		this.goNextStep ();
	}
	
	,goNextStep: function ()
	{
		this.$('assistant').moveNext ();
	}
});

